#include "quik.h"
#include "prom.h"
#include <string.h>

char bootdevice[512];
static char current_devname[512];
static ihandle current_dev;

int open(char *device)
{
    current_dev = call_prom("open", 1, 1, device);
    if (current_dev == (ihandle) 0 || current_dev == (ihandle) -1) {
	printf("\nCouldn't open %s\n", device);
	return -1;
    }
    strcpy(current_devname, device);
    return 0;
}

int diskinit()
{
    char *p;

    prom_get_chosen("bootpath", bootdevice, sizeof(bootdevice));
    if (bootdevice[0] == 0) {
	prom_get_options("boot-device", bootdevice, sizeof(bootdevice));
	if (bootdevice[0] == 0)
	    fatal("Couldn't determine boot device");
    }
    p = strchr(bootdevice, ':');
    if (p != 0)
	*p = 0;
    return open(bootdevice);
}

int read(char *buf, int nbytes, long long offset)
{
    int nr;

    if (nbytes == 0)
	return 0;

    call_prom("seek", 3, 1, current_dev, (unsigned int) (offset >> 32),
	      (unsigned int) (offset & 0xFFFFFFFF));
    nr = (int) call_prom("read", 3, 1, current_dev, buf, nbytes);
    return nr;
}

void close()
{
}

int setdisk(char *device)
{
    if (strcmp(device, current_devname) == 0)
	return 0;
    close();
    return open(device);
}
